//--------------------------------------------------------------------------
//--------------------------------------------------------------------------
// 		        	    Scene Farts Display Roztine
//--------------------------------------------------------------------------
//--------------------------------------------------------------------------
//      Scripting stuff (PO, functions, macros)
//--------------------------------------------------------------------------
.function FindC64Col(rgb) {
    .var c64col = -1
    .for (var cidx=0; cidx<16; cidx++) {
        .if (rgb == C64ColList.get(cidx)) .eval c64col = cidx
    }
    .if (c64col == -1) .print "Selected C64-palette does not contain RGB = " + rgb
.return c64col
}
//--------------------------------------------------------------------------
.function gappos_left(rasline) {
.return 2*(rasline - $30)
}
//--------------------------------------------------------------------------
.function gappos_right(rasline) {
.return gappos_left(rasline) + 1
}
//--------------------------------------------------------------------------
.macro carboncopy(register, page) {
        lda register
carboncopy:
        sta page*$100
        inc carboncopy+1
}
//--------------------------------------------------------------------------
//      Variables
//--------------------------------------------------------------------------
		.const zpa              =   $81
		.const zpx              =   $82
		.const zpy              =   $83
		.const SMOKE_SPRPTR0    =   $17
//--------------------------------------------------------------------------
//      Palette definitions
//--------------------------------------------------------------------------
		//RGB values Pepto
		.const C64ColList = List().add($000000, $ffffff, $68372b, $70a4b2)
		.eval           C64ColList.add($6f3d86, $588d43, $352879, $b8c76f)
		.eval           C64ColList.add($6f4f25, $433900, $9a6759, $444444)
		.eval           C64ColList.add($6c6c6c, $9ad284, $6c5eb5, $959595)
		//RGB values Deekay
		//.const C64ColList = List().add($000000, $ffffff, $851f02, $65cda8)
		//.eval           C64ColList.add($a73b9f, $4dab19, $1a0c92, $ebe353)
		//.eval           C64ColList.add($a94b02, $441e00, $d28074, $464646)
		//.eval           C64ColList.add($8b8b8b, $8ef68e, $4d91d1, $bababa)
//--------------------------------------------------------------------------
//      Load GFX data
//--------------------------------------------------------------------------		
		.const pic_hires = LoadPicture("gfxdata/hires.png")
		.const pic_layer0 = LoadPicture("gfxdata/spr-layer0.png", List().add(1, 0))
		.const pic_layer1 = LoadPicture("gfxdata/spr-layer1.png", List().add(1, 0))
		.const beltsprite = LoadPicture("gfxdata/beltsprite.png")
		.const sigsprite = LoadPicture("gfxdata/sigsprite.png")
		.const pic_smoke = LoadPicture("gfxdata/smoke.png")
        .const bordercol_left = LoadPicture("gfxdata/raster_left.png")
        .const bordercol_right = LoadPicture("gfxdata/raster_right.png")
//--------------------------------------------------------------------------
//      GFX data parsing of underlying Hires picture
//--------------------------------------------------------------------------		
		.const Bitmap_List = List()
		.const Vram_List = List()
		.for (var charline = 0; charline < 25; charline++) {
		    .for (var charpos = 0; charpos < 40; charpos++) {
		        .var col0 = FindC64Col(pic_hires.getPixel(8*charpos, 8*charline))
		        .var col1 = 0
		        .for (var line = 0; line < 8; line++) {
		            .var byte_tmp = 0
		            .for (var pix = 0; pix < 8; pix++) {
    		            .var pixcol = FindC64Col(pic_hires.getPixel(8*charpos + pix, 8*charline + line))
		                .if (pixcol != col0) {
    		                .eval col1 = pixcol
    		                .eval byte_tmp += pow(2, 7-pix)
    		            }
    		        }    
    		        .eval Bitmap_List.add(byte_tmp) 
		        }
		        .eval Vram_List.add($10*col1 + col0)
		    }
		}
//--------------------------------------------------------------------------
//      Parsing of sideborder colours
//--------------------------------------------------------------------------		
		.const BGRCOL_LIST = List()
		.for (var line=0; line < 200; line++) {
		    .eval BGRCOL_LIST.add(FindC64Col(bordercol_left.getPixel(0, line)))
		    .eval BGRCOL_LIST.add(FindC64Col(bordercol_right.getPixel(0, line)))
		}
		.eval BGRCOL_LIST.add($0, $0, $0)
//--------------------------------------------------------------------------
//      Main
//--------------------------------------------------------------------------
		*= $08dc
start:
		lda #$7f
		sta $dc0d
		sta $dd0d
		sta $d019
   		lda #<nmi
		sta $fffa
		lda #>nmi
		sta $fffb
		
		lda #$35
		sta $01
        
		lda $dc0d
		lda $dd0d
		
		lda #$00
		sta $d017
		sta $d01b
		sta $d01c
		
		sta $dc0e
		sta $dc0f
		sta $dd0e
		sta $dd0f
		
        sta $dd04
        sta $dd05
		lda #$81
        sta $dd0d
        ldx #$11
        stx $dd0e
        
		lda #$08
		sta $d016
		lda #$08
		sta $d018
        
		lda #$38
		sta $d011
		lda #$04
		sta $d012
		lda #<spr_irq
		sta $fffe
		lda #>spr_irq
		sta $ffff
        lda #$01
		sta $d01a
wc:		
		jmp wc
//--------------------------------------------------------------------------
delay:
        dex
        bne delay
        rts
//--------------------------------------------------------------------------
//		Sprite-IRQ
//--------------------------------------------------------------------------
spr_irq:
        sta zpa        
        //:carboncopy($d012, $33)
        
        //stx zpx
        //sty zpy
        // not needed, spr_irq uses accu only
        
        lda #$38
		sta $d011
        
        lda #$05
	    sta $d003
	    sta $d005
	    sta $d007
	    
	    lda #SMOKE_SPRPTR0
	    sta $43f9
	    sta $c3f9
	    lda #SMOKE_SPRPTR0 + 1*$8
	    sta $43fa
	    sta $c3fa
	    lda #SMOKE_SPRPTR0 + 2*$8
	    sta $43fb
	    sta $c3fb
        
	    lda #$1a
	    sta $d009
	    sta $d00b
	    sta $d00f
	    
	    lda #$2f
	    sta $d001
	    sta $d00d
	    
	    lda #$07
	    sta $d028
	    sta $d029
	    sta $d02a
	    sta $d02b
	    sta $d02c
	    sta $d02e
        
        lda #$00
        sta $d027
        sta $d02d
ld_frame_flag:
		lda #$00
		sta ld_xpos_spr5 + 1
		ora #$10
		sta $d000
		ora #$20
		sta $d00c
		eor #$31
		sta ld_frame_flag + 1
		asl
		sta $dd00
         
	    //:carboncopy($d012, $30)
        
        lda #$10
	    sta $43f8
	    sta $c3f8
	    lda #SMOKE_SPRPTR0 + 3*$8
	    sta $43fc
	    sta $c3fc
	    lda #SMOKE_SPRPTR0 + 4*$8
	    sta $43fd
	    sta $c3fd
	    lda #$16
	    sta $43fe
	    sta $c3fe
	    lda #SMOKE_SPRPTR0 + 5*$8
	    sta $43ff
	    sta $c3ff
        
        //:carboncopy($d012, $35)
        
        lda #$fe
	    sta $d015
        lda #<irq
        sta $fffe
        lda #$22
        sta $d012
        jmp irq_end+4
//--------------------------------------------------------------------------
//      Main-IRQ
//--------------------------------------------------------------------------
irq:	
        sty zpy
        stx zpx
		sta zpa
        
        ldy #$03
next_line_dejitter:
        nop
//--------------------------------------------------------------------------
//      page break here
//      *= $0a00
//--------------------------------------------------------------------------
variance_decr:
        ldx $d012
		dey
		bne variance_decr
		ldy #$04
		
		cpx $d012
		beq *+2
		cpx #$2b
		bne next_line_dejitter
endvarkill:
//--------------------------------------------------------------------------
//      following code starts at rasline $2c @cyc=18
//--------------------------------------------------------------------------
		lda #$2f
	    sta $d003-4,y
	    sta $d005-4,y
	    sta $d007-4,y
	    sta $d009
	    sta $d00b
	    lda #$00
	    sta $d028
	    sta $d029-4,y
	    sta $d02a-4,y
	    
	    lda #$13
	    ldx #$14
//--------------------------------------------------------------------------
//      rasline $2d
//--------------------------------------------------------------------------
	    sta $43fb-4,y
	    sta $c3fb-4,y
        stx $43fc
	    stx $c3fc
	    inx
	    sax $43f9
	    sax $c3f9
	    stx $43fd
	    stx $c3fd
	    inx
	    sax $43fa
	    sax $c3fa        
        
        lsr $d015		
//--------------------------------------------------------------------------
//      rasline $2e
//--------------------------------------------------------------------------
        lda $d000
        clc
        adc #$30
        sta $d002-4,y
        adc #$30
        sta $d004-4,y
        adc #$30
        sta $d006-4,y
        nop
        nop
        lda #$e0
        ldx #$f8
        ldy #$60
        sta $d008-$60,y
        stx $d00e
        sty $d010
        
        lda #$cf
//--------------------------------------------------------------------------
//      rasline $2f
//--------------------------------------------------------------------------
        sta $d01d-$60,y
ld_xpos_spr5:
        lda #$ff
        sta $d00a-$60,y
        sty $d02c
        nop
        nop
        nop
        ldy #$ff
        ora #$d0
        ldx #BGRCOL_LIST.get(gappos_left($31))
        sta $d008
        lda #BGRCOL_LIST.get(gappos_left($30))
        sax $d02b
        sty $d01d
//--------------------------------------------------------------------------
//      cycle position: rasline $2f @cyc=53
//--------------------------------------------------------------------------
        sta $d020
//--------------------------------------------------------------------------
//      rasline $30
//--------------------------------------------------------------------------
flicolcopy_loop:
        .var spr_yref = $2f
        .var sprptr_st_hi_adr = flicolcopy_loop + $12b
        .for (var line=$30; line<$f8; line++) {
            .var rel_line = line - $30
            .var sprptr_ofs = floor((rel_line) / 16) + 2 + 1
            .if (line>spr_yref) .eval spr_yref += 21
            .if (mod(rel_line, 8) == 0) {
                .if (line == $30) {
                    stx $d020
                } else {
                    sty $d020
                }
            } else {
                .if (mod(rel_line, 8) == 1) {
                    .if (spr_yref != $101) {
                        lda #spr_yref
                        bit $ea
                        sta $d001
                        sta $d003
                        sta $d005
                        sta $d007
                        sta $d009
                        sta $d00b
                        sta $d00d
                    } else {
                        nop
                        nop
                        nop
                        ldx #$03    //3*5+1 cycles = 16 cycles
                        jsr delay   //12 cycles (jsr + rts)
                        //:carboncopy($d000, $37)
                        //:carboncopy($d002, $39)
                    }
                }
                .if ((mod(rel_line, 16) > 1 && mod(rel_line, 16) < 6) || (mod(rel_line, 16) > 9 && mod(rel_line, 16) < 14)) {
                    nop
                    nop
                    nop
                    ldx #$03    //3*5+1 cycles = 16 cycles
                    jsr delay   //12 cycles (jsr + rts)
                }
                .if (mod(rel_line, 16) == 6) {
                    nop
                    nop
                    ldx #$03    //3*5+1 cycles = 16 cycles
                    jsr delay   //12 cycles (jsr + rts)
                    ldy #BGRCOL_LIST.get(gappos_left(line+3))                
                }
                .if (mod(rel_line, 16) == 7) {
                    .if (rel_line < 199) {
                        lda sprptr_st_hi_adr
                        eor #$80
                        sta sprptr_st_hi_adr+$00
                        sta sprptr_st_hi_adr+$03
                        sta sprptr_st_hi_adr+$06
                        sta sprptr_st_hi_adr+$0a
                        sta sprptr_st_hi_adr+$0d
                        sta sprptr_st_hi_adr+$11
                        sta sprptr_st_hi_adr+$14
                        .eval sprptr_st_hi_adr += $14a
                    } else {
                        nop
                        lda #$a0-8
                        sta $d000
                        lda #$05
                        sta $d027
                        ldx #$01    //1*5+1 = 6cycles
                        jsr delay   //12cycles
                        //ldx #$00  // loop exits with x=0
                        ldy #$0b
                    }
                }
                .if (mod(rel_line, 16) == 14) {
                    nop
                    ldx #$03    //3*5+1 cycles = 16 cycles
                    jsr delay   //12 cycles (jsr + rts)
                    ldx #(8*sprptr_ofs) + 4
                    ldy #BGRCOL_LIST.get(gappos_left(line+3))                
                }
                .if (mod(rel_line, 16) == 15) {
                    lda #(8*sprptr_ofs) + 3
                    sax $c3f8
                    sta $c3fb
                    stx $c3fc
                    inx
                    sax $c3f9
                    stx $c3fd
                    inx
                    sax $c3fa
                    stx $c3fe
                }
                lda #BGRCOL_LIST.get(gappos_right(line))
                sta $d020
                lda #BGRCOL_LIST.get(gappos_left(line+1))
                sta $d020
            }
        }
//--------------------------------------------------------------------------
//      rasline $f8
//--------------------------------------------------------------------------
        stx $d01d
        sty $d02d
        lda #$31
        sta $d00c
        
		lda #$30
		sta $d011
		lda #$04
		sta $d012
        
        //:carboncopy($d012, $33)
        
		lda #$fa-8
		sta $d002
		sta $d008
		lda #$12-8
		sta $d004
		sta $d00a
		lda #$2a-8
		sta $d006
		sta $d00e
		lda #$ec
		sta $d010
		lda #$0e
		sta $d015
		lda #<spr_irq
		sta $fffe
//--------------------------------------------------------------------------
irq_end:
		ldy zpy		//zpy = $85
		ldx zpx		//zpx = $83
		lda zpa		//zpa = $81
		dec $d019
nmi:	rti
//--------------------------------------------------------------------------
//      VRam Frame 0
//--------------------------------------------------------------------------
* = $4000
.fill Vram_List.size(), Vram_List.get(i)
//--------------------------------------------------------------------------
//      Sprite Ptr Frame 0
//--------------------------------------------------------------------------
*= $43f8
.byte $00, $01, $02, $03, $04, $05, $06, $ff
//--------------------------------------------------------------------------
//      Sprite Data parsing for outlines (layer for frame 0)
//--------------------------------------------------------------------------
//      *= $4400
//--------------------------------------------------------------------------
		.for (var sprnum=0; sprnum<7; sprnum++) {
        		.var SprData_Adr = $4400 + $40*sprnum
	    	    .for (var virtline = 0; virtline < 200; virtline++) {
		            .var rel_sline = mod(virtline, 21)
		            .var spr_blk = floor(virtline/16)
		            *= SprData_Adr + (8*spr_blk)*$40 + 3*rel_sline
		            .byte pic_layer0.getSinglecolorByte(3*sprnum    , virtline)
		            .byte pic_layer0.getSinglecolorByte(3*sprnum + 1, virtline)
		            .byte pic_layer0.getSinglecolorByte(3*sprnum + 2, virtline)
		        }
//--------------------------------------------------------------------------
//      Sprite Data parsing for belt&sig = lower border sprites (frame 0)
//--------------------------------------------------------------------------
		        .if (sprnum == 0) {
		            .for (var xtraline = 0; xtraline < 3; xtraline++) {
		                .byte beltsprite.getSinglecolorByte(0, xtraline)
		                .byte beltsprite.getSinglecolorByte(1, xtraline)
		                .byte beltsprite.getSinglecolorByte(2, xtraline)
		            }
		        }
		        .if (sprnum == 6) {
		            .for (var xtraline = 0; xtraline < 10; xtraline++) {
		                .byte sigsprite.getSinglecolorByte(0, xtraline)
		                .byte sigsprite.getSinglecolorByte(1, xtraline)
		                .byte sigsprite.getSinglecolorByte(2, xtraline)
		            }
		        }
		}
//--------------------------------------------------------------------------
//      Sprite Data parsing for smoke = upper border sprites (frame 0)
//--------------------------------------------------------------------------
		.for (var sprnum = 0; sprnum < 3; sprnum++) {
		    .var adrtmp = $4000 + (SMOKE_SPRPTR0 + $8*sprnum) * $40
		    *= adrtmp
    		.for (var line = 0; line < 42; line++) {
    		    .if (line == 21) {
    		        *= adrtmp + 3*$8*$40
    		    }
	    	    .var gfxline = line - 6
		        .if (gfxline < 0) {
		            .byte $00, $00, $00
		        }
                .if (gfxline >= 0 && gfxline < 35) {
		                .byte pic_smoke.getSinglecolorByte(3*sprnum + 0, gfxline)
		                .byte pic_smoke.getSinglecolorByte(3*sprnum + 1, gfxline)
		                .byte pic_smoke.getSinglecolorByte(3*sprnum + 2, gfxline)
		        }
		        .if (gfxline == 35) {
		            .if (sprnum < 2) {
		                .byte pic_smoke.getSinglecolorByte(3*sprnum + 0, gfxline)
		                .byte pic_smoke.getSinglecolorByte(3*sprnum + 1, gfxline)
		                .byte pic_smoke.getSinglecolorByte(3*sprnum + 2, gfxline)
		            } else {
		                .byte $ff, $ff, $ff
		            }
		       }
		    } 
		}
//--------------------------------------------------------------------------
		.for (var sprnum = 0; sprnum < 2; sprnum++) {
    	    .var destsprnum = sprnum + 4
		    *= $4400 + destsprnum * $40 + 3*19
            .byte pic_smoke.getSinglecolorByte(3*sprnum + 0, 34)
		    .byte pic_smoke.getSinglecolorByte(3*sprnum + 1, 34)
		    .byte pic_smoke.getSinglecolorByte(3*sprnum + 2, 34)
		    .if (sprnum == 0) {
		        .byte $00, $00, $00
		    } else {
           		.byte $0e, $a0, $00
	        }
		}
//--------------------------------------------------------------------------
//      Bitmap Frame 0
//--------------------------------------------------------------------------
* = $6000
.fill Bitmap_List.size(), Bitmap_List.get(i)
//--------------------------------------------------------------------------
//      Vram Frame 1
//--------------------------------------------------------------------------
* = $c000
.fill Vram_List.size(), Vram_List.get(i) 
//--------------------------------------------------------------------------
//      Sprite Ptr Frame 1
//--------------------------------------------------------------------------
*= $c3f8
.byte $00, $01, $02, $03, $04, $05, $06, $ff
//--------------------------------------------------------------------------
//      Sprite Data parsing for outlines (layer for frame 1)
//--------------------------------------------------------------------------
//      *= $c400
//--------------------------------------------------------------------------
		.for (var sprnum=0; sprnum<7; sprnum++) {
        		.var SprData_Adr = $c400 + $40*sprnum
	    	    .for (var virtline = 0; virtline < 200; virtline++) {
		            .var rel_sline = mod(virtline, 21)
		            .var spr_blk = floor(virtline/16)
		            *= SprData_Adr + (8*spr_blk)*$40 + 3*rel_sline
		            .byte pic_layer1.getSinglecolorByte(3*sprnum    , virtline)
		            .byte pic_layer1.getSinglecolorByte(3*sprnum + 1, virtline)
		            .byte pic_layer1.getSinglecolorByte(3*sprnum + 2, virtline)
		        }    
//--------------------------------------------------------------------------
//      Sprite Data parsing for belt&sig = lower border sprites (frame 1)
//--------------------------------------------------------------------------
		            .if (sprnum == 0) {
		                .for (var xtraline = 0; xtraline < 3; xtraline++) {
		                    .byte beltsprite.getSinglecolorByte(0, xtraline)
		                    .byte beltsprite.getSinglecolorByte(1, xtraline)
		                    .byte beltsprite.getSinglecolorByte(2, xtraline)
		                }
		            }
		            .if (sprnum == 6) {
		                .for (var xtraline = 0; xtraline < 10; xtraline++) {
		                    .byte sigsprite.getSinglecolorByte(0, xtraline)
		                    .byte sigsprite.getSinglecolorByte(1, xtraline)
		                    .byte sigsprite.getSinglecolorByte(2, xtraline)
		                }
		            }
		        
		}
//--------------------------------------------------------------------------
//      Sprite Data parsing for smoke = upper border sprites (frame 1)
//--------------------------------------------------------------------------
		.for (var sprnum = 0; sprnum < 3; sprnum++) {
		    .var adrtmp = $c000 + (SMOKE_SPRPTR0 + $8*sprnum) * $40
		    *= adrtmp
    		.for (var line = 0; line < 42; line++) {
    		    .if (line == 21) {
    		        *= adrtmp + 3*$8*$40
    		    }
	    	    .var gfxline = line - 6
		        .if (gfxline < 0) {
		            .byte $00, $00, $00
		        }
                .if (gfxline >= 0 && gfxline < 35) {
		                .byte pic_smoke.getSinglecolorByte(3*sprnum + 0, gfxline)
		                .byte pic_smoke.getSinglecolorByte(3*sprnum + 1, gfxline)
		                .byte pic_smoke.getSinglecolorByte(3*sprnum + 2, gfxline)
		        }
		        .if (gfxline == 35) {
		            .if (sprnum < 2) {
		                .byte pic_smoke.getSinglecolorByte(3*sprnum + 0, gfxline)
		                .byte pic_smoke.getSinglecolorByte(3*sprnum + 1, gfxline)
		                .byte pic_smoke.getSinglecolorByte(3*sprnum + 2, gfxline)
		            } else {
		                .byte $ff, $ff, $ff
		            }
		        }		        
		    } 
		}
//--------------------------------------------------------------------------
		.for (var sprnum = 0; sprnum < 2; sprnum++) {
		    .var destsprnum = sprnum + 4
		    *= $c400 + destsprnum * $40 + 3*19
            .byte pic_smoke.getSinglecolorByte(3*sprnum + 0, 34)
            .byte pic_smoke.getSinglecolorByte(3*sprnum + 1, 34)
            .byte pic_smoke.getSinglecolorByte(3*sprnum + 2, 34)
	        .if (sprnum == 0) {
	            .byte $00, $00, $00
	        } else {
           		.byte $1d, $40, $00
            }
         }
//--------------------------------------------------------------------------
//      Bitmap Frame 1
//--------------------------------------------------------------------------
* = $e000
.fill Bitmap_List.size(), Bitmap_List.get(i)
//--------------------------------------------------------------------------
// eof
//--------------------------------------------------------------------------
